// Generated by purs version 0.11.6

// | Wraps the functions of Javascript's `String` object.

// | A String represents a sequence of characters.

// | For details of the underlying implementation, see [String Reference at MDN](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String).
"use strict";
var $foreign = require("./foreign");
var Control_Semigroupoid = require("../Control.Semigroupoid");
var Data_Eq = require("../Data.Eq");
var Data_Function = require("../Data.Function");
var Data_Maybe = require("../Data.Maybe");
var Data_Newtype = require("../Data.Newtype");
var Data_Ord = require("../Data.Ord");
var Data_Ordering = require("../Data.Ordering");
var Data_Ring = require("../Data.Ring");
var Data_Semigroup = require("../Data.Semigroup");
var Data_Semiring = require("../Data.Semiring");
var Data_Show = require("../Data.Show");
var Data_String_Unsafe = require("../Data.String.Unsafe");
var Prelude = require("../Prelude");

// | A newtype used in cases to specify a replacement for a pattern.
var Replacement = function (x) {
    return x;
};

// | A newtype used in cases where there is a string to be matched.

// |

// | ```purescript

// | pursPattern = Pattern ".purs"

// | --can be used like this:

// | contains pursPattern "Test.purs"

// |    == true

// | ```

// |
var Pattern = function (x) {
    return x;
};

// | Returns the first character and the rest of the string,

// | if the string is not empty.

// |

// | ```purescript

// | uncons "" == Nothing

// | uncons "Hello World" == Just { head: 'H', tail: "ello World" }

// | ```

// |
var uncons = function (v) {
    if (v === "") {
        return Data_Maybe.Nothing.value;
    };
    return new Data_Maybe.Just({
        head: Data_String_Unsafe.charAt(0)(v), 
        tail: $foreign.drop(1)(v)
    });
};

// | Converts the string to a character, if the length of the string is

// | exactly `1`.

// |

// | ```purescript

// | toChar "l" == Just 'l'

// | toChar "Hi" == Nothing -- since length is not 1

// | ```

// |
var toChar = $foreign._toChar(Data_Maybe.Just.create)(Data_Maybe.Nothing.value);

// | Returns the longest prefix (possibly empty) of characters that satisfy

// | the predicate.

// |

// | ```purescript

// | takeWhile (_ /= ':') "http://purescript.org" == "http"

// | ```

// |
var takeWhile = function (p) {
    return function (s) {
        return $foreign.take($foreign.count(p)(s))(s);
    };
};

// | Returns the substrings of a split at the given index, if the index is within bounds.

// |

// | ```purescript

// | splitAt 2 "Hello World" == Just { before: "He", after: "llo World"}

// | splitAt 10 "Hi" == Nothing

// | ```

// |
var splitAt = $foreign._splitAt(Data_Maybe.Just.create)(Data_Maybe.Nothing.value);
var showReplacement = new Data_Show.Show(function (v) {
    return "(Replacement " + (Data_Show.show(Data_Show.showString)(v) + ")");
});
var showPattern = new Data_Show.Show(function (v) {
    return "(Pattern " + (Data_Show.show(Data_Show.showString)(v) + ")");
});

// | Returns `true` if the given string is empty.

// |

// | ```purescript

// | null "" == true

// | null "Hi" == false

// | ```

// |
var $$null = function (s) {
    return s === "";
};
var newtypeReplacement = new Data_Newtype.Newtype(function (n) {
    return n;
}, Replacement);
var newtypePattern = new Data_Newtype.Newtype(function (n) {
    return n;
}, Pattern);

// | Compare two strings in a locale-aware fashion. This is in contrast to

// | the `Ord` instance on `String` which treats strings as arrays of code

// | units:

// |

// | ```purescript

// | "ä" `localeCompare` "b" == LT

// | "ä" `compare` "b" == GT

// | ```

// |
var localeCompare = $foreign._localeCompare(Data_Ordering.LT.value)(Data_Ordering.EQ.value)(Data_Ordering.GT.value);

// | Returns the index of the last occurrence of the pattern in the

// | given string, starting at the specified index 

// | and searching backwards towards the beginning of the string. 

// | Returns `Nothing` if there is no match.

// |

// | ```purescript

// | lastIndexOf' (Pattern "a") 1 "ababa" == Just 0

// | lastIndexOf' (Pattern "a") 3 "ababa" == Just 2

// | lastIndexOf' (Pattern "a") 4 "ababa" == Just 4

// | ```

// |
var lastIndexOf$prime = $foreign["_lastIndexOf'"](Data_Maybe.Just.create)(Data_Maybe.Nothing.value);

// | Returns the index of the last occurrence of the pattern in the

// | given string. Returns `Nothing` if there is no match.

// |

// | ```purescript

// | lastIndexOf (Pattern "c") "abcdc" == Just 4

// | lastIndexOf (Pattern "c") "aaa" == Nothing

// | ```

// |
var lastIndexOf = $foreign._lastIndexOf(Data_Maybe.Just.create)(Data_Maybe.Nothing.value);

// | If the string ends with the given suffix, return the portion of the

// | string left after removing it, as a `Just` value. Otherwise, return

// | `Nothing`.

// |

// | ```purescript

// | stripSuffix (Pattern ".exe") "psc.exe" == Just "psc"

// | stripSuffix (Pattern ".exe") "psc" == Nothing

// | ```

// |
var stripSuffix = function (v) {
    return function (str) {
        var v1 = lastIndexOf(v)(str);
        if (v1 instanceof Data_Maybe.Just && v1.value0 === ($foreign.length(str) - $foreign.length(v) | 0)) {
            return Data_Maybe.Just.create($foreign.take(v1.value0)(str));
        };
        return Data_Maybe.Nothing.value;
    };
};

// | Returns the index of the first occurrence of the pattern in the

// | given string, starting at the specified index. Returns `Nothing` if there is

// | no match.

// |

// | ```purescript

// | indexOf' (Pattern "a") 2 "ababa" == Just 2

// | indexOf' (Pattern "a") 3 "ababa" == Just 4

// | ```

// |
var indexOf$prime = $foreign["_indexOf'"](Data_Maybe.Just.create)(Data_Maybe.Nothing.value);

// | Returns the index of the first occurrence of the pattern in the

// | given string. Returns `Nothing` if there is no match.

// |

// | ```purescript

// | indexOf (Pattern "c") "abcdc" == Just 2

// | indexOf (Pattern "c") "aaa" == Nothing

// | ```

// |
var indexOf = $foreign._indexOf(Data_Maybe.Just.create)(Data_Maybe.Nothing.value);

// | If the string starts with the given prefix, return the portion of the

// | string left after removing it, as a Just value. Otherwise, return Nothing.

// |

// | ```purescript

// | stripPrefix (Pattern "http:") "http://purescript.org" == Just "//purescript.org"

// | stripPrefix (Pattern "http:") "https://purescript.org" == Nothing

// | ```

// |
var stripPrefix = function (v) {
    return function (str) {
        var v1 = indexOf(v)(str);
        if (v1 instanceof Data_Maybe.Just && v1.value0 === 0) {
            return Data_Maybe.Just.create($foreign.drop($foreign.length(v))(str));
        };
        return Data_Maybe.Nothing.value;
    };
};
var eqReplacement = new Data_Eq.Eq(function (x) {
    return function (y) {
        return x === y;
    };
});
var ordReplacement = new Data_Ord.Ord(function () {
    return eqReplacement;
}, function (x) {
    return function (y) {
        return Data_Ord.compare(Data_Ord.ordString)(x)(y);
    };
});
var eqPattern = new Data_Eq.Eq(function (x) {
    return function (y) {
        return x === y;
    };
});
var ordPattern = new Data_Ord.Ord(function () {
    return eqPattern;
}, function (x) {
    return function (y) {
        return Data_Ord.compare(Data_Ord.ordString)(x)(y);
    };
});

// | Returns the suffix remaining after `takeWhile`.

// |

// | ```purescript

// | dropWhile (_ /= '.') "Test.purs" == ".purs"

// | ```

// |
var dropWhile = function (p) {
    return function (s) {
        return $foreign.drop($foreign.count(p)(s))(s);
    };
};

// | Checks whether the pattern appears in the given string.

// |

// | ```purescript

// | contains (Pattern "needle") "haystack with needle" == true

// | contains (Pattern "needle") "haystack" == false

// | ```

// |
var contains = function (pat) {
    return function ($48) {
        return Data_Maybe.isJust(indexOf(pat)($48));
    };
};

// | Returns the numeric Unicode value of the character at the given index,

// | if the index is within bounds.

// | ```purescript

// | charCodeAt 2 "5 €" == Just 0x20AC

// | charCodeAt 10 "5 €" == Nothing

// | ```

// |
var charCodeAt = $foreign._charCodeAt(Data_Maybe.Just.create)(Data_Maybe.Nothing.value);

// | Returns the character at the given index, if the index is within bounds.

// |

// | ```purescript

// | charAt 2 "Hello" == Just 'l'

// | charAt 10 "Hello" == Nothing

// | ```

// |
var charAt = $foreign._charAt(Data_Maybe.Just.create)(Data_Maybe.Nothing.value);
module.exports = {
    Pattern: Pattern, 
    Replacement: Replacement, 
    charAt: charAt, 
    charCodeAt: charCodeAt, 
    contains: contains, 
    dropWhile: dropWhile, 
    indexOf: indexOf, 
    "indexOf'": indexOf$prime, 
    lastIndexOf: lastIndexOf, 
    "lastIndexOf'": lastIndexOf$prime, 
    localeCompare: localeCompare, 
    "null": $$null, 
    splitAt: splitAt, 
    stripPrefix: stripPrefix, 
    stripSuffix: stripSuffix, 
    takeWhile: takeWhile, 
    toChar: toChar, 
    uncons: uncons, 
    eqPattern: eqPattern, 
    ordPattern: ordPattern, 
    newtypePattern: newtypePattern, 
    showPattern: showPattern, 
    eqReplacement: eqReplacement, 
    ordReplacement: ordReplacement, 
    newtypeReplacement: newtypeReplacement, 
    showReplacement: showReplacement, 
    count: $foreign.count, 
    drop: $foreign.drop, 
    fromCharArray: $foreign.fromCharArray, 
    joinWith: $foreign.joinWith, 
    length: $foreign.length, 
    replace: $foreign.replace, 
    replaceAll: $foreign.replaceAll, 
    singleton: $foreign.singleton, 
    split: $foreign.split, 
    take: $foreign.take, 
    toCharArray: $foreign.toCharArray, 
    toLower: $foreign.toLower, 
    toUpper: $foreign.toUpper, 
    trim: $foreign.trim
};
